//   ......:	 : 1-wire  PIC16            										  					

#include "1wire_pic16.h"	
							 							 
//    1-wire
unsigned char init_DS(void)																																   	 /*=14*/
{ 
  //"0" -  
  //"1" -  
	unsigned char check;
	
	DQin = 0;
	DQ = 0;  																	// "0"  DQ	
	Delay_us(500);														// 500   
	DQin = 1;                              			// "1"  DQ
	Delay_us(70);															// 70   
	check = DQ;						    							// 
	Delay_us(223);														//    223
	
	return(check);  						   						
}                     											
						    
//   1-wire
unsigned char read_bit(void)
{	
	DQ=0;
	DQin = 0;
  Delay_us(2);			// 2 
	DQin=1;
  Delay_us(10);			// 10 
		
	return(DQ);
}

//   1-wire
void write_bit(unsigned char b)
{	
  DQin = 0;
	DQ = 0;
	Delay_us(2);				  // 2 
	if(b == 1) DQin = 1;																				
	Delay_us(100);				// 100 
	DQin = 1;
	Delay_us(1);				  // 1 				 
}	

//     1-wire
void write_byte(unsigned char byte)  					   		 //<byte> -   
{ 
	unsigned char r, temp;    											 	 // 
	
	for (r = 0; r < 8; r++)    			     							 // 8   
	{ 
		temp=byte>>r;   							  								 // 
		temp &= 0x01;
		write_bit(temp);						
	}  																			  				 //   8 =30  
  Delay_us(106);  																	// 106
}                      											 				


//   c  1-wire
unsigned char read_byte(void)   				   				 		// READ  1-wire=74*/
{ 
	unsigned char i;       							  							//  =75*/
	unsigned char d=0,s=0;
	
	for (i = 0; i < 8; i++)    									 				//  8 =78*/
	{ 
		s = read_bit()<<( i);
		d = d | s;
		Delay_us(136);				
	}	
	return (d);      							     	
}                       							
																	
